<?php

$data_manager = new NNR_Data_Manager_v1( self::$data_manager_table_name );
$data_manager_settings = new NNR_Data_Manager_Settings_v1(self::$prefix_dash, self::$text_domain);
$display_conditions_settings = new NNR_Display_Conditions_Settings_v1(self::$prefix_dash, self::$text_domain);
$newsletter_settings = new NNR_Newsletter_Integrations_Settings_v1(self::$prefix_dash, self::$text_domain);

$settings = self::default_data();

// Edit Data

if ( isset($_GET['action']) && $_GET['action'] == 'edit' && isset($_GET['data_id']) && $_GET['data_id'] != '' ) {
	$settings = $data_manager->get_data_from_id($_GET['data_id']);
}

$display_conditions = $settings['display_conditions'];
$args = $settings['args'];
$newsletter = $settings['args']['newsletter'];

// Show the preview

if ( isset($_GET['alt_action']) && $_GET['alt_action'] == 'preview' ) {

	NNR_Interstitial_Overlays::display_overlay($_GET['data_id']);

}

// Save data and check nonce

if (isset($_POST['submit']) && check_admin_referer(self::$prefix . 'admin_settings')) {

	// Get Data

	$data = $data_manager_settings->get_data();
	$display_data = $display_conditions_settings->get_data();
	$newsletter_data = $newsletter_settings->get_data();

	// Add Data

	if ( !isset($settings['args']) || !is_array($settings['args']) ) {
		$settings['args'] = array();
	}

	$settings = array_merge($settings, $data);
	$settings['display_conditions'] = $display_data;
	$settings['args']['newsletter'] = $newsletter_data;

	// Save all Interstitial Data

	$settings['args']['content'] = isset($_POST[self::$prefix_dash . 'content']) ? stripcslashes(htmlentities($_POST[self::$prefix_dash . 'content'])) : '';

	$settings['args']['content_type'] = isset($_POST[self::$prefix_dash . 'content-type']) ? $_POST[self::$prefix_dash . 'content-type'] : 'announcement';

	$settings['args']['content_size'] = isset($_POST[self::$prefix_dash . 'content-size']) ? stripcslashes(htmlentities($_POST[self::$prefix_dash . 'content-size'])) : '';

	$settings['args']['use_close_button'] = isset($_POST[self::$prefix_dash . 'use-close-button']) && $_POST[self::$prefix_dash . 'use-close-button'] ? true : false;

	$settings['args']['wait_time'] = isset($_POST[self::$prefix_dash . 'wait-time']) ? sanitize_text_field($_POST[self::$prefix_dash . 'wait-time']) : '0';

	$settings['args']['continue_button_text'] = isset($_POST[self::$prefix_dash . 'continue-button-text']) ? sanitize_text_field($_POST[self::$prefix_dash . 'continue-button-text']) : __('Continue ...' , self::$prefix_dash);

	$settings['args']['dont_show_again'] = isset($_POST[self::$prefix_dash . 'dont-show-again']) && $_POST[self::$prefix_dash . 'dont-show-again'] ? true : false;

	$settings['args']['powered_by'] = isset($_POST[self::$prefix_dash . 'powered-by']) && $_POST[self::$prefix_dash . 'powered-by'] ? true : false;

	// Self Hosted Ad

	$settings['args']['ad_type'] = isset($_POST[self::$prefix_dash . 'ad-type']) ? sanitize_text_field($_POST[self::$prefix_dash . 'ad-type']) : '';

	$settings['args']['ad_image'] = isset($_POST[self::$prefix_dash . 'ad-image']) ? sanitize_text_field($_POST[self::$prefix_dash . 'ad-image']) : '';

	$settings['args']['ad_image_link'] = isset($_POST[self::$prefix_dash . 'ad-image-link']) ? sanitize_text_field($_POST[self::$prefix_dash . 'ad-image-link']) : '';

	$settings['args']['ad_destination_link'] = isset($_POST[self::$prefix_dash . 'ad-destination-link']) ? sanitize_text_field($_POST[self::$prefix_dash . 'ad-destination-link']) : '';

	$settings['args']['ad_destination_target'] = isset($_POST[self::$prefix_dash . 'ad-destination-target']) ? sanitize_text_field($_POST[self::$prefix_dash . 'ad-destination-target']) : '';

	$settings['args']['ad_destination_rel'] = isset($_POST[self::$prefix_dash . 'ad-destination-rel']) && $_POST[self::$prefix_dash . 'ad-destination-rel'] ? true : false;

	// Third Party Ad

	$settings['args']['third_ad_code'] = isset($_POST[self::$prefix_dash . 'third-ad-code']) ? stripcslashes(htmlentities($_POST[self::$prefix_dash . 'third-ad-code'])) : '';

	// Button Link

	$settings['args']['button_text'] = isset($_POST[self::$prefix_dash . 'button-text']) ? stripcslashes(sanitize_text_field($_POST[self::$prefix_dash . 'button-text'])) : '';

	$settings['args']['button_link'] = isset($_POST[self::$prefix_dash . 'button-link']) ? sanitize_text_field($_POST[self::$prefix_dash . 'button-link']) : '';

	$settings['args']['button_target'] = isset($_POST[self::$prefix_dash . 'button-target']) ? sanitize_text_field($_POST[self::$prefix_dash . 'button-target']) : '';

	$settings['args']['button_rel'] = isset($_POST[self::$prefix_dash . 'button-rel']) && $_POST[self::$prefix_dash . 'button-rel'] ? true : false;

	$settings['args']['button_background_color'] = isset($_POST[self::$prefix_dash . 'button-background-color']) ? sanitize_text_field($_POST[self::$prefix_dash . 'button-background-color']) : '';

	$settings['args']['button_text_color'] = isset($_POST[self::$prefix_dash . 'button-text-color']) ? sanitize_text_field($_POST[self::$prefix_dash . 'button-text-color']) : '';

	// Age Verifier

	$settings['args']['minimum_age'] = isset($_POST[self::$prefix_dash . 'minimum-age']) ? sanitize_text_field($_POST[self::$prefix_dash . 'minimum-age']) : '18';

	$settings['args']['age_verifier_error_text'] = isset($_POST[self::$prefix_dash . 'age-verifier-error-text']) ? stripcslashes(sanitize_text_field($_POST[self::$prefix_dash . 'age-verifier-error-text'])) : __('You are not old enough to enter the site.', self::$text_domain);

	$settings['args']['age_verifier_button_text'] = isset($_POST[self::$prefix_dash . 'age-verifier-button-text']) ? stripcslashes(sanitize_text_field($_POST[self::$prefix_dash . 'age-verifier-button-text'])) : __('Verify', self::$text_domain);

	$settings['args']['age_verifier_button_background_color'] = isset($_POST[self::$prefix_dash . 'age-verifier-button-background-color']) ? sanitize_text_field($_POST[self::$prefix_dash . 'age-verifier-button-background-color']) : '';

	$settings['args']['age_verifier_button_text_color'] = isset($_POST[self::$prefix_dash . 'age-verifier-button-text-color']) ? sanitize_text_field($_POST[self::$prefix_dash . 'age-verifier-button-text-color']) : '';

	// Acceptance Text

	$settings['args']['require_checkbox'] = isset($_POST[self::$prefix_dash . 'require-checkbox']) && $_POST[self::$prefix_dash . 'require-checkbox'] ? true : false;

	$settings['args']['confirm_text'] = isset($_POST[self::$prefix_dash . 'confirm-text']) ? stripcslashes(sanitize_text_field($_POST[self::$prefix_dash . 'confirm-text'])) : __('I have read and agreed to the Terms & Conditions.', self::$text_domain);

	$settings['args']['acceptance_button_text'] = isset($_POST[self::$prefix_dash . 'acceptance-button-text']) ? stripcslashes(sanitize_text_field($_POST[self::$prefix_dash . 'acceptance-button-text'])) : __('I Accept', self::$text_domain);

	$settings['args']['acceptance_button_background_color'] = isset($_POST[self::$prefix_dash . 'acceptance-button-background-color']) ? sanitize_text_field($_POST[self::$prefix_dash . 'acceptance-button-background-color']) : '';

	$settings['args']['acceptance_button_text_color'] = isset($_POST[self::$prefix_dash . 'acceptance-button-text-color']) ? sanitize_text_field($_POST[self::$prefix_dash . 'acceptance-button-text-color']) : '';

	// Style Data

	$settings['args']['style'] = array(
		'background_type'          => isset($_POST[self::$prefix_dash . 'background-type']) ? sanitize_text_field($_POST[self::$prefix_dash . 'background-type']) : 'pattern',
		'background_image'         => isset($_POST[self::$prefix_dash . 'background-image']) ?sanitize_text_field($_POST[self::$prefix_dash . 'background-image']) : '',
		'background_color'         => isset($_POST[self::$prefix_dash . 'background-color']) ? sanitize_text_field($_POST[self::$prefix_dash . 'background-color']) : '#ffffff',
		'background_pattern'       => isset($_POST[self::$prefix_dash . 'background-pattern']) ? sanitize_text_field($_POST[self::$prefix_dash . 'background-pattern']) : 'none',
		'background_size'          => isset($_POST[self::$prefix_dash . 'background-size']) ? $_POST[self::$prefix_dash . 'background-size'] : 'auto',
		'background_repeat'        => isset($_POST[self::$prefix_dash . 'background-repeat']) ? $_POST[self::$prefix_dash . 'background-repeat'] : 'no-repeat',
		'background_position'      => isset($_POST[self::$prefix_dash . 'background-position']) ? $_POST[self::$prefix_dash . 'background-position'] : 'center center',
		'header_text_color'        => isset($_POST[self::$prefix_dash . 'header-text-color']) ? $_POST[self::$prefix_dash . 'header-text-color'] : '#333333',
		'header_background_color'  => isset($_POST[self::$prefix_dash . 'header-background-color']) ? $_POST[self::$prefix_dash . 'header-background-color'] : '#f8f8f8',
		'header_border_color'      => isset($_POST[self::$prefix_dash . 'header-border-color']) ? $_POST[self::$prefix_dash . 'header-border-color'] : '#333333',
	);

	if ( isset($_GET['action']) && $_GET['action'] == 'edit' ) {

		$data_manager->update_data($_GET['data_id'], $settings);

		// Redirect to the same page

		?>
		<script type="text/javascript">
			window.location = window.location + "<?php echo (isset($_POST[self::$prefix_dash . 'preview-field']) && $_POST[self::$prefix_dash . 'preview-field'] ? '&alt_action=preview' : ''); ?>";
		</script>
		<?php

	} else {

		$data_manager->add_data($settings);

		// Redirect to the dashboard page after the creatation of something

		?>
		<script type="text/javascript">
			window.location = "<?php echo get_admin_url(); ?>admin.php?page=<?php echo self::$dashboard_page; ?>&status_type=success&status_message=<?php echo urlencode(__("Please note that the Overlay you just created is not activated yet.  To activate it simply click the activate button to the left of the Overlay on this page. This is to prevent accidental sitewide publication.", self::$text_domain)); ?>";
		</script>
		<?php
	}
}

include_once(NNROBOTS_INTERSTITIAL_OVERLAYS_PLUGIN_DIR . 'views/add-edit.php');