jQuery(document).ready(function($){

	// Record Impression

	$.post(nnr_io_data.ajaxurl, {
			'action': 'nnr_stats_record_impression_v1',
			'data_id': nnr_io_data.data_id,
			'table_name': nnr_io_data.stats_table_name
		}, function(response) {

		console.log(response);
	});

	// Set Cookie

	$.post(nnr_io_data.ajaxurl, {
			'action': 'nnr_io_set_cookie',
			'data_id': nnr_io_data.data_id
		}, function(response) {

		console.log(response);
	});

	$('html,body').css('overflow', 'hidden');

	var counter = nnr_io_data.wait_time;

	// Dismiss Overlay

	$('.' + nnr_io_data.prefix + 'header').click(function(){

		if ( nnr_io_data.close_button ) {
			$('.' + nnr_io_data.prefix + 'wrap').remove();
			$('html,body').css('overflow', 'initial');
		}
	});

	// Add text to header for wait time

	if ( !nnr_io_data.close_button && counter > 0 ) {

		$('.' + nnr_io_data.prefix + 'header').append('<span style="padding-left:12px;" class="' + nnr_io_data.prefix + 'timer">' + nnr_io_data.wait_time + '</span>');

		setInterval(function() {

			counter--;

			if (counter >= 0) {
				$('.' + nnr_io_data.prefix + 'timer').html(counter);
			}

			// Display 'counter' wherever you want to display it.

			if (counter === 0) {
				clearInterval(counter);
				$('.' + nnr_io_data.prefix + 'timer').remove();
				$('.' + nnr_io_data.prefix + 'header').click(function(){
					$('.' + nnr_io_data.prefix + 'wrap').remove();
					$('html,body').css('overflow', 'initial');
				});
			}

		}, 1000);

	} else {
		$('.' + nnr_io_data.prefix + 'header').click(function(){
			$('.' + nnr_io_data.prefix + 'wrap').remove();
			$('html,body').css('overflow', 'initial');
		});
	}

	// Ad

	$('.' + nnr_io_data.prefix + 'ad-link').click(function(){
		nnr_io_record_conversion();
	});

	// Button Link

	$('.' + nnr_io_data.prefix + 'button-link').click(function(){
		nnr_io_record_conversion();
	});

	// Age Verifier

	$('.' + nnr_io_data.prefix + 'age-verifier-button').click(function(){

		$('.' + nnr_io_data.prefix + 'age-verifier-error-text').remove();

		// Parse the date given

		var date = $('.' + nnr_io_data.prefix + 'age-verifier-year').val() + "-" + $('.' + nnr_io_data.prefix + 'age-verifier-month').val() + "-" + $('.' + nnr_io_data.prefix + 'age-verifier-day').val();
		var birthday = moment(date);

		if ( birthday.isValid() ) {

			if ( birthday.unix() < ( moment().unix() - ( 60 * 60 * 24 * 365.25 * nnr_io_data.minimum_age ) ) ) {
				$('.' + nnr_io_data.prefix + 'wrap').remove();
				$('html,body').css('overflow', 'initial');
				nnr_io_record_conversion();
			} else {
				$('.' + nnr_io_data.prefix + 'age-verifier-wrap').append('<p class="' + nnr_io_data.prefix + 'age-verifier-error-text">' + nnr_io_data.age_verifier_error_text + '</p>');
			}

		} else {
			$('.' + nnr_io_data.prefix + 'age-verifier-wrap').append('<p class="' + nnr_io_data.prefix + 'age-verifier-error-text">' + nnr_io_data.age_verifier_error_text + '</p>');
		}

	});

	// Acceptance

	if ( $('.' + nnr_io_data.prefix + 'acceptance-checkbox').length != 0 && $('.' + nnr_io_data.prefix + 'acceptance-checkbox').prop('checked') ) {

		$('.' + nnr_io_data.prefix + 'acceptance-button').click(function(){
			$('.' + nnr_io_data.prefix + 'wrap').remove();
			$('html,body').css('overflow', 'initial');
			nnr_io_record_conversion();
		});

	} else {
		$('.' + nnr_io_data.prefix + 'acceptance-button').click(function(){
			$('.' + nnr_io_data.prefix + 'wrap').remove();
			$('html,body').css('overflow', 'initial');
			nnr_io_record_conversion();
		});
	}

	/**
	 * Records a conversion
	 *
	 * @access public
	 * @return void
	 */
	function nnr_io_record_conversion() {

		$.post(nnr_io_data.ajaxurl, {
				'action': 'nnr_stats_record_conversion_v1',
				'data_id': nnr_io_data.data_id,
				'table_name': nnr_io_data.stats_table_name
			}, function(response) {

			console.log(response);
		});

	}

});